#Filter Created by Logstone

from pymclevel import TAG_List
from pymclevel import TAG_Byte
from pymclevel import TAG_Int
from pymclevel import TAG_Compound
from pymclevel import TAG_Short
from pymclevel import TAG_Float
from pymclevel import TAG_Double
from pymclevel import TAG_String
import math

displayName = "Shrink blocks #Improved"

inputs = (
        ("Usable versions are 1.9~", "label"),
	("Size",("Head",
			"Small Head",
			"Handheld",
			"Small Handheld",
			)),
        ("Invisible", True),
        ("Lighten (Only Surface)", False),
        ("Scraping Terrain", True)
)

def perform(level, box, options):
	for x in xrange(box.minx, box.maxx):
		for z in xrange(box.minz, box.maxz):
			for y in xrange(box.miny, box.maxy):
				
				if level.blockAt(x, y, z) != 0:
				
					Scale = options["Size"]
					Invisible = options["Invisible"]
					Lighten = options["Lighten (Only Surface)"]
					scraping = options["Scraping Terrain"]
					block = "minecraft:" + (level.materials[level.blockAt(x, y, z)].stringID)
					damage = level.blockDataAt(x, y, z)
                                        
					if Scale == "Head":
						j = .625
						j1 = .625
						j2 = .625
						i = 1.75
						if block == "minecraft:skull":
							j = .595
							j1 = .595
							j2 = .595
							i = 1.65
						
					if Scale == "Small Head":
						j = .465
						j1 = .465
						j2 = .465
						i = .4675
						if x != box.minx:
							j = .4375
						if z != box.minx:
							j1 = .4375
					
					if Scale == "Handheld":
						j = .37
						j1 = .37
						j2 = .37
						i = .4675
					
					if Scale == "Small Handheld":
						j = .188
						j1 = .188
						j2 = .185
						i = .4675
						if x != box.minx:
							j = .185
						if z != box.minx:
                                                        j1 = .185
				
					k = ((x - box.minx) * j) + box.minx + .25
					l = (((y-i) - box.miny) * j2) + box.miny
					m = ((z - box.minz) * j1) + box.minz + .25
					
					a = int(math.floor(k))
					b = int(math.floor(l))
					c = int(math.floor(m))
					
                                        puttable = False
                                        if Lighten == True:
                                                puttable = CheckSolid(level, x, y, z, box)
                                        
                                        if puttable == False:
                                                stand = SetStand(x, y, z, block, damage, k, l, m, Scale, Invisible)

                                        if scraping == True:
                                                level.setBlockAt(x, y, z, 0)
					
					
					chunk = level.getChunk(a/16, c/16)
					chunk.Entities.append(stand)
					chunk.dirty = True

def IsNormal(level, x, y, z, box):
        if x < box.minx or y < box.miny or z < box.minz or x >= box.maxx or y >= box.maxy or z >= box.maxz:
                return False

        if level.blockAt(x, y, z) == 0:
                return False
        
        _type = level.materials[level.blockAt(x, y, z)].type
        
        if _type == "NORMAL":
                return True
        return False

def CheckSolid(level, x, y, z, box):
        up = IsNormal(level,x,y+1,z,box)
        bottom = IsNormal(level,x,y-1,z,box)
        north = IsNormal(level,x-1,y,z,box)
        south = IsNormal(level,x+1,y,z,box)
        east = IsNormal(level,x,y,z-1,box)
        west = IsNormal(level,x,y,z+1,box)
        if up == True and bottom == True and north == True and south == True and east == True and west == True:
                return True
        return False
                                
        
def SetStand(x, y, z, block, damage, k, l, m, Scale, Invisible):
	stand = TAG_Compound()
	stand["id"] = TAG_String("minecraft:armor_stand")
	stand["Equipment"] = TAG_List()
	iF1 = TAG_Compound()
	if Scale == "Handheld" or Scale == "Small Handheld":
		if block == 144:
			iF5["id"] = TAG_String("minecraft:skull")
		else:
			iF1["id"] = TAG_String(block)
		iF1["Damage"] = TAG_Short(damage)
		iF1["Count"] = TAG_Byte(1)
	iF2 = TAG_Compound()
	iF3 = TAG_Compound()
	iF4 = TAG_Compound()
	iF5 = TAG_Compound()
	if Scale == "Head" or Scale == "Small Head":
		if block == "minecraft:skull":
			iF5["id"] = TAG_String("minecraft:skull")
		else:
			iF5["id"] = TAG_String(block)
		iF5["Damage"] = TAG_Short(damage)
                iF5["Count"] = TAG_Byte(1)
	stand["ArmorItems"] = TAG_List()
	stand["HandItems"] = TAG_List()
	stand["HandItems"].append(iF1)
	stand["HandItems"].append(TAG_Compound())
	
	stand["ArmorItems"].append(iF2)
	stand["ArmorItems"].append(iF3)
	stand["ArmorItems"].append(iF4)
	stand["ArmorItems"].append(iF5)
	
	stand["NoGravity"] = TAG_Byte(1)
	
	if Invisible == True:
                stand["Invisible"] = TAG_Byte(1)
	else:
                stand["Invisible"] = TAG_Byte(0)

        
	stand["PersistenceRequired"] = TAG_Byte(1)
	stand["Invulnerable"] = TAG_Byte(1)
	if Scale == "Small Head" or Scale == "Small Handheld":
		stand["Small"] = TAG_Byte(1)
	if Scale == "Handheld":
		stand["Pose"] = TAG_Compound()
		stand["Pose"]["RightArm"] = TAG_List()
		stand["Pose"]["RightArm"].append(TAG_Float(-14.05))
		stand["Pose"]["RightArm"].append(TAG_Float(-46.0))
		stand["Pose"]["RightArm"].append(TAG_Float(0.0))
	if Scale == "Small Handheld":
		stand["Pose"] = TAG_Compound()
		stand["Pose"]["RightArm"] = TAG_List()
		stand["Pose"]["RightArm"].append(TAG_Float(-14.05))
		stand["Pose"]["RightArm"].append(TAG_Float(-46.0))
		stand["Pose"]["RightArm"].append(TAG_Float(0.0))
		
		stand["Rotation"] = TAG_List()
		#stand["Rotation"].append(TAG_Float(44.9))
		#stand["Rotation"].append(TAG_Float(0))
	
		
	stand["Pos"] = TAG_List()
	stand["Pos"].append(TAG_Double(k))
	stand["Pos"].append(TAG_Double(l))
	stand["Pos"].append(TAG_Double(m))
	
	return stand
